<?php

//
//  Todo List Module Plugin
//
//  Copyright (c) 2003 Bjarne Maschoreck <bjarne.maschoreck@satconsulting.dk>
//  Licensed under the GNU GPL. For full terms see the file COPYING.
//

function approve_todo_admin() {
    global $username;

/**********************************************************************
   Users that have access to the shared todo administration interface
    should be entered into the following array.
***********************************************************************/
/*
    $admins = array(	"bjarne.maschoreck@satconsulting.dk",
			"bjarne@maschoreck.dk",
			"bjarne.maschoreck@satdevelopment.dk",
			"bjarne@tvpc.dk",
			"jan.iversen@satconsulting.dk");
*/

    $admins = array(	"sysop");

/**********************************************************************   
 *    Then those users can go to Options->Shared Todo List
 *    Administration.  
**********************************************************************/


    $approved = false; 
    if (isset($_SESSION['username'])) {
        $username = $_SESSION['username'];
    }
    foreach ($admins as $admin) {
        if (isset($username)) {
            if (strtolower($username) == strtolower($admin)) {
                $approved = true;
            }
        }
    }
    return $approved;
}

function squirrelmail_plugin_init_todo() {
    global $squirrelmail_plugin_hooks;
    $approved = approve_todo_admin();
    $squirrelmail_plugin_hooks["menuline"]["todo"] = "todo";
    if ($approved == true) { 
        $squirrelmail_plugin_hooks['optpage_register_block']['todo'] = 'todo_admin_block';
    }
}

function todo() {
    //Add Todo link to upper menu

   // include compatibility plugin
   //
   if (defined('SM_PATH'))
      include_once(SM_PATH . 'plugins/compatibility/functions.php');
   else if (file_exists('../plugins/compatibility/functions.php'))
      include_once('../plugins/compatibility/functions.php');
   else if (file_exists('./plugins/compatibility/functions.php'))
      include_once('./plugins/compatibility/functions.php');

    if (compatibility_check_sm_version(1, 3)) {
       bindtextdomain('todo', SM_PATH . 'plugins/todo/locale');
       textdomain('todo');
    } else {
       bindtextdomain('todo', '../plugins/todo/locale');
       textdomain('todo');
    }

    displayInternalLink("plugins/todo/todo_check.php",_("Todo"),"right");
    echo "&nbsp;&nbsp\n";

    if (compatibility_check_sm_version(1, 3)) {
        bindtextdomain('squirrelmail', SM_PATH . 'locale');
        textdomain('squirrelmail');
    } else {
        bindtextdomain('squirrelmail', '../locale');
        textdomain('squirrelmail');
    }


}

function todo_admin_block() {
    global $optpage_blocks;

   // include compatibility plugin
   //
   if (defined('SM_PATH'))
      include_once(SM_PATH . 'plugins/compatibility/functions.php');
   else if (file_exists('../plugins/compatibility/functions.php'))
      include_once('../plugins/compatibility/functions.php');
   else if (file_exists('./plugins/compatibility/functions.php'))
      include_once('./plugins/compatibility/functions.php');

    if (compatibility_check_sm_version(1, 3)) {
       bindtextdomain('todo', SM_PATH . 'plugins/todo/locale');
       textdomain('todo');
    } else {
       bindtextdomain('todo', '../plugins/todo/locale');
       textdomain('todo');
    }

    $optpage_blocks[] = array(
        'name' => _("Shared Todo List Administration"),
        'url'  => '../plugins/todo/admin_options.php',
        'desc' => _("Create and maintain shared todo lists. Assign access by user or create publicly available todo lists"),
        'js'   => false
        );

    if (compatibility_check_sm_version(1, 3)) {
        bindtextdomain('squirrelmail', SM_PATH . 'locale');
        textdomain('squirrelmail');
    } else {
        bindtextdomain('squirrelmail', '../locale');
        textdomain('squirrelmail');
    }


}

?>
